//
//  ViewController.m
//  PieChartTest
//
//  Created by Developer Support on 3/28/14.
//  Copyright (c) 2014 Developer Support. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    _data = [[NSMutableArray alloc] init];
    _data = (NSMutableArray*)[self createSimpleData:25];
    _source = [[IGPieChartViewDataSourceHelper alloc]initWithData:_data valuePath:@"value" labelPath:@"label"];
    _infraPieChart = [[IGPieChartView alloc] init];
    _infraPieChart.frame = CGRectMake(0, 50, self.view.frame.size.width, self.view.frame.size.height - 50);
    _infraPieChart.autoresizingMask = UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleHeight;
    _infraPieChart.dataSource = _source;
    _infraPieChart.theme = [self createCustomTheme];
    _infraPieChart.backgroundColor = [UIColor clearColor];
	_infraPieChart.labelsPosition = IGLabelsPositionOutsideEnd;
    [self.view addSubview:_infraPieChart];
    
    IGLegend* legend = [[IGLegend alloc]initWithLegendType:IGChartLegendTypeItem];
    legend.layer.borderColor = [UIColor grayColor].CGColor;
    legend.layer.borderWidth = 2;
    legend.frame = CGRectMake(5, 25, self.view.frame.size.width - 10, 45);
    legend.autoresizingMask = UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleBottomMargin;
    legend.horizontalAlignment = IGHorizontalAlignStretch;
    legend.verticalAlignment = IGVerticalAlignCenter;
    legend.orientation = IGOrientationHorizontal;
    legend.layer.cornerRadius = 8;
    legend.layer.masksToBounds = YES;
    _infraPieChart.legend = legend;
    [self.view addSubview:legend];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (NSMutableArray*) createSimpleData:(int)recordCount
{
    NSMutableArray* retValue = [[NSMutableArray alloc] init];
    for (int i = 0; i < recordCount; i++)
    {
        SimpleData* data = [[SimpleData alloc]initWithValue:i andLabel:[NSString stringWithFormat:@"Slice %d", i]];
        [retValue addObject:data];
    }
    return retValue;
}

-(IGPieChartThemeDefinition*)createCustomTheme
{
    IGPieChartThemeDefinition *def = [[IGPieChartThemeDefinition alloc]init];
    def.font = [UIFont fontWithName:@"Helvetica" size:12];
    def.fontColor = [[IGBrush alloc] initWithR:0 andG:0 andB:0 andA:1];
    def.backgroundColor = [UIColor whiteColor];
    def.legendFont = [UIFont fontWithName:@"Helvetica" size:12];
    def.legendFontColor = [[IGBrush alloc] initWithR:0 andG:0 andB:0 andA:1];
    def.legendBorderThickness = 1;
    def.legendPalette = [[IGChartPaletteItem alloc]init];
    def.legendPalette.color = [[IGBrush alloc] initWithR:0.9 andG:0.9 andB:0.9 andA:0.8];
    def.legendPalette.outlineColor = [[IGBrush alloc] initWithR:0.7 andG:0.7 andB:0.7 andA:1];
    
    IGChartPaletteItem* item1 = [[IGChartPaletteItem alloc] init];
    item1.outlineColor = [[IGBrush alloc] initWithR:0.69 andG:0.75 andB:0.79 andA:1];
    item1.color = [[IGBrush alloc] initWithR:0.31 andG:0.65 andB:0.74 andA:1];
    [def.slicePalettes addObject:item1];
    
    IGChartPaletteItem* item2 = [[IGChartPaletteItem alloc] init];
    item2.outlineColor = [[IGBrush alloc] initWithR:0.47 andG:0.53 andB:0.58 andA:1];
    item2.color = [[IGBrush alloc] initWithR:0.98 andG:0.40 andB:0.33 andA:1];
    [def.slicePalettes addObject:item2];
    
    IGChartPaletteItem* item3 = [[IGChartPaletteItem alloc] init];
    item3.outlineColor = [[IGBrush alloc] initWithR:0.31 andG:0.38 andB:0.42 andA:1];
    item3.color = [[IGBrush alloc] initWithR:0.99 andG:0.76 andB:0.23 andA:1];
    [def.slicePalettes addObject:item3];
    
    IGChartPaletteItem* item4 = [[IGChartPaletteItem alloc] init];
    item4.outlineColor = [[IGBrush alloc] initWithR:0.21 andG:0.27 andB:0.31 andA:1];
    item4.color = [[IGBrush alloc] initWithR:0.23 andG:0.39 andB:0.6 andA:1];
    [def.slicePalettes addObject:item4];
    
    IGChartPaletteItem* item5 = [[IGChartPaletteItem alloc] init];
    item5.outlineColor = [[IGBrush alloc] initWithR:0.08 andG:0.17 andB:0.23 andA:1];
    item5.color = [[IGBrush alloc] initWithR:0.57 andG:0.69 andB:0.29 andA:1];
    [def.slicePalettes addObject:item5];
    
    IGChartPaletteItem* others = [[IGChartPaletteItem alloc] init];
    others.outlineColor = [[IGBrush alloc] initWithR:0.50 andG:0.50 andB:0.50 andA:1];
    others.color = [[IGBrush alloc] initWithR:0.33 andG:0.05 andB:1.0 andA:1];
    def.othersCategoryFont = [UIFont fontWithName:@"Helvetica" size:12];
    def.othersCategoryFontColor = [[IGBrush alloc] initWithR:0 andG:0 andB:0 andA:1];
    def.othersCategoryThickness = 1.0;
    def.othersCategoryPalette = others;
    
    IGChartPaletteItem* selected = [[IGChartPaletteItem alloc] init];
    selected.outlineColor = [[IGBrush alloc] initWithR:0.50 andG:0.50 andB:0.50 andA:1];
    selected.color = [[IGBrush alloc] initWithR:0.16 andG:0.81 andB:1 andA:1];
    def.selectedFont = [UIFont fontWithName:@"Helvetica" size:12];
    def.selectedFontColor = [[IGBrush alloc] initWithR:0 andG:0 andB:0 andA:1];
    def.selectedThickness = 1.0;
    def.selectedPalette = selected;
    
    IGChartPaletteItem* leaderLine = [[IGChartPaletteItem alloc] init];
    leaderLine.outlineColor = [[IGBrush alloc] initWithR:0.10 andG:0.10 andB:0.10 andA:1];
    leaderLine.color = [[IGBrush alloc] initWithR:0.10 andG:0.10 andB:0.10 andA:1];
    def.leaderLineThickness = 1.0;
    def.leaderLinePalette = leaderLine;
    return def;
}

@end
@implementation SimpleData
@synthesize value, label;

-(id)initWithValue:(double)_value andLabel:(NSString*)_label
{
    self = [super init];
    if (self)
    {
        self.value = _value;
        self.label = _label;
    }
    return self;
}

@end